import os
import shutil
from pprint import pprint
import glob
import re
from datoeenos import tools,conf

def convert_cp(pfile,log,plan_name,owner=None):
    cplan={}
    pdata=tools.readconfig(pfile,log)
    if bool(pdata):
        # print(pfile)
        # pprint(pdata)
        
        for item in pdata:
            if pdata[item]=="ON":
                pdata[item]="on"
            if pdata[item]=="OFF":
                pdata[item]="off"
            if item=='ssh':
                if pdata[item]=="off":
                    pdata[item]="no"
                else:
                    pdata[item]="yes"        
        if bool(pdata):
            # pprint(pdata)
            cplan=conf.default_package(plan_name)
            # Set the same plan name
            cplan['name']=plan_name
            try:
                if owner:
                    cplan['owner']=owner
                else:
                    fowner=str(pfile).split('/')[-3]                    
                    cplan['owner']=fowner                    
            except Exception as e:
                log(str(e))
                # Set the default plan owner as root             
                cplan['owner']='admin'
                pass            
            plan_maps=conf.package_map()
            for item in pdata:
                try:
                    cplan[plan_maps[item]]=pdata[item]
                except Exception:
                    pass    
                cplan['feature']='Default'
        else:
            cplan=conf.default_package(plan_name)
    else:
        cplan=conf.default_package(plan_name)    
    # pprint(cplan)    
    return cplan

def get_cp_packages(log):
    packages={}
    if os.path.isdir('/usr/local/directadmin/data/users/admin/packages'):
        pfiles=glob.glob('/usr/local/directadmin/data/users/*/packages/*.pkg')  
        pfiles.sort()
        if bool(pfiles):
            for pfile in pfiles:
                if os.path.isfile(pfile):                     
                    pname=pfile.split('/')[-1]
                    plan_name=str(pname).split(".")[0]
                    log("Converting Directadmin Package : %s" %plan_name)
                    packages[plan_name]=convert_cp(pfile,log,plan_name)
                    # packages[plan_name]=dict()
    if bool(packages):                                    
        return(packages)
    else:
        return dict()

def convert(choice,log):
    log("--------------------------------")
    log("Directadmin Packages conversion")
    log("--------------------------------")
    # pprint(choice)
    basedir=choice['myworkdir']
    workdir=basedir+'/EenosHostingPackages'
    uploadpath=str(choice['saveto'])+'/EenosHostingPackages'
    result=None
    try:
        if os.path.isdir(uploadpath):
            log("Cleaning upload path : %s" %uploadpath)
            shutil.rmtree(uploadpath)
        if os.path.isdir(workdir):
            log("Cleaning work dir : %s" %workdir)
            shutil.rmtree(workdir)
        if not os.path.isdir(workdir):
            log("re-creating work dir : %s" %workdir)
            os.makedirs(workdir)
    except Exception as e:
        log(str(e))
        pass

    log("Collecting  Directadmin Hosting packages ..")
    cp_pksgs=get_cp_packages(log)
    if bool(cp_pksgs):
        for package in cp_pksgs:
            pfile= workdir+'/'+package+'.yaml'
            log("Creating Eenos package file  [ %s ] => [ %s]" %(package,pfile))
            try:
                tools.writeyaml(pfile,cp_pksgs[package],log)
            except Exception as e:
                log(str(e))
                pass
        # pprint(choice)
        
        log("Copying Eenos package files to Upload Folder : %s" %uploadpath)
        try:
            shutil.copytree(workdir,uploadpath)
            log("Cleanigng work directory")
            shutil.rmtree(workdir) 
            log("Please Upload all the  Package files from %s to your Eenos Server Pacakge folder /var/eenos/packages/" %uploadpath) 
            log("The Directadmin to Eenos  package conversion completed")         
            log("Eenos Hosting Packages : %s" %uploadpath)
            result= uploadpath       
        except Exception as e:
            log(str(e))
            pass
    else:
        log("Unable to generate Eenos packages !!!")
    return result
