import os,sys
import shutil
from pprint import pprint
import glob,pwd
import re
from datoeenos import tools,commands,directadmin,tarops,bkpconvert

def convert(choice,log):    
    cpuser=choice['user']
    log("--------------------------------------")
    log(" User Account conversion : %s" %cpuser)
    log("--------------------------------------")
    basedir=choice['myworkdir']         
    result=None
    cresult=None
    try:
        adminhome=str(pwd.getpwnam('admin').pw_dir)
    except Exception as e:
        log(str(e))
        adminhome='/tmp'
        pass
    destiname=adminhome+'/da2eenos_backups'   
    cmd='/usr/local/directadmin/directadmin admin-backup --destination='+destiname+' --user='+cpuser
    bkp=None
    try:
        log("Generating directadmin account backup ... please wait")
        log(cmd)
        commands.live(cmd,log)
        ufiles=glob.glob(destiname+'/*.'+cpuser+'.*')
        if bool(ufiles):
            # pprint(ufiles)
            bkp=ufiles[0]
        else:
            bkp=None       
    except Exception as e:
        log(str(e))
        bkp=None
        pass
    if bkp and os.path.isfile(bkp):
        log("Backup file generated : %s" %bkp)
        wname=bkpconvert.get_tempdir(bkp)    
        workdir=basedir+'/'+wname  
        result=None
        try:
            if os.path.isdir(workdir):
                log("Cleaning work directory : %s" %workdir)
                shutil.rmtree(workdir)
        except Exception as e:
            log(str(e))
            pass
        cresult=bkpconvert.extract_tar(bkp,workdir,log) 
        try:
            os.unlink(bkp) 
        except Exception as e:
            log(str(e))
            pass      
    if cresult and os.path.isdir(cresult):
        log("Directadmin backup extracted successfully  : %s" %cresult)
        log("Proceeding with backup conversion")
        backup=directadmin.start(cpuser,cresult,choice,log)
        if backup:
            outputfile=backup+'.tar.gz'
            archfile=tarops.make_gzip_tar_from_dir(outputfile,backup,log)
            if archfile:
                pkgname=str(archfile).split('/')[-1]
                log("Directadmin account converted successfully  : %s " %pkgname)
                uploadpath=str(choice['saveto'])+'/'+pkgname
                try:
                    log("Uploading Eenos backup to : %s" %uploadpath)
                    shutil.copy(archfile,uploadpath)
                    result=uploadpath
                except Exception as e:
                    log(str(e))
                    result=None
                    pass
                try:
                    log("Cleaning temporary backup files .. %s" %backup)                    
                    shutil.rmtree(backup)
                    os.remove(archfile)
                except Exception as e:
                    log(str(e))
                    pass
                if result:
                    log("===================================")
                    log("Your Eenos Backup is : %s" %result)
                    tools.get_hash(result,log)
                else:
                    log("Directadmin to Eenos conversion failed.")                    
            else:
                log("Unable to create archive backup file , backup failed")
                result=None
        else:
            log("Directadmin to Eenos account conversion failed !!!") 
    else:
        log("Directadmin backup generation failed. Unable to converet backup to eenos ")    
    return result
    # pprint(choice)